_tinkerforge_device()
{
	local prev

	for (( i=$1; i > 0; i-- )); do
		prev="${COMP_WORDS[i-1]}"

		case "${prev}" in
		get-*|is-*|are-*|abort-async-file-read|allocate-list|allocate-string|append-to-list|calibrate|continue-program-schedule|create-directory|create-pipe|create-session|define-program|edge-interrupt|expire-session|keep-session-alive|kill-process|open-directory|open-file|purge-program|read|read-file|read-frame|read-wifi2-serial-port|release-object|remove-custom-program-option|remove-from-list|rewind-directory|save-calibration|save-wifi2-configuration|set-custom-program-option-value|set-file-events|set-file-position|set-program-command|set-program-schedule|set-program-stdio-redirection|set-string-chunk|spawn-process|start-program|start-wifi2-bootloader|truncate-string|write|write-file|write-frame|write-wifi2-serial-port|acceleration|acceleration-reached|air-pressure|air-pressure-reached|alarm|all-data|altitude|altitude-reached|ambient-temperature|ambient-temperature-reached|analog-value|analog-value-reached|angular-velocity|async-file-read|async-file-write|beep-finished|button-pressed|button-released|co2-concentration|co2-concentration-reached|color|color-reached|color-temperature|coordinates|count|count-reached|counter-finished|current|current-reached|current-velocity|date-time|detection-cycle-ended|distance|distance-reached|dust-density|dust-density-reached|edge-count|emergency-shutdown|error|error-callback|error-state|file-events-occurred|frame-read|frame-rendered|gravity-vector|humidity|humidity-reached|illuminance|illuminance-reached|intensity|intensity-reached|interrupt|linear-acceleration|magnetic-field|moisture|moisture-reached|monoflop-done|morse-code-finished|motion|motion-detected|new-state|object-temperature|object-temperature-reached|orientation|over-current|position|position-reached|power|power-reached|pressed|process-state-changed|program-process-spawned|program-scheduler-state-changed|quaternion|read|read-callback|reflectivity|reflectivity-reached|released|resistance|resistance-reached|stack-current|stack-current-reached|stack-voltage|stack-voltage-reached|state-changed|status|switching-done|temperature|temperature-reached|tilt-state|touch-state|under-voltage|usb-voltage|usb-voltage-reached|uv-light|uv-light-reached|velocity|velocity-reached|voltage|voltage-reached|weight|weight-reached)
			COMPREPLY=($(compgen -W "--help --execute" -- ${cur}))
			break
			;;
		set-*|authenticate-mifare-classic-page|backlight-off|backlight-on|beep|calibrate|clear-display|dim-socket-b|disable|disable-frame-read-callback|disable-frame-rendered-callback|disable-laser|disable-position-reached-callback|disable-read-callback|disable-status-led|disable-tilt-state-callback|disable-velocity-reached-callback|disable-wifi2-status-led|drive-backward|drive-forward|enable|enable-frame-read-callback|enable-frame-rendered-callback|enable-laser|enable-position-reached-callback|enable-read-callback|enable-status-led|enable-tilt-state-callback|enable-velocity-reached-callback|enable-wifi2-status-led|expire-session-unchecked|full-brake|led-off|led-on|leds-off|leds-on|light-off|light-on|morse-code|new-window|orientation-calculation-off|orientation-calculation-on|read-file-async|recalibrate|refresh-wifi-status|release-object-unchecked|request-page|request-tag-id|reset|restart|start-counter|stop|switch-socket|switch-socket-a|switch-socket-b|switch-socket-c|tare|write|write-file-async|write-file-unchecked|write-line|write-page)
			COMPREPLY=($(compgen -W "--help --expect-response" -- ${cur}))
			break
			;;
		call)
			local functions=$(tinkerforge call $2 --list-functions)
			COMPREPLY=($(compgen -W "--help --list-functions ${functions}" -- ${cur}))
			break
			;;
		dispatch)
			local callbacks=$(tinkerforge dispatch $2 --list-callbacks)
			COMPREPLY=($(compgen -W "--help --list-callbacks ${callbacks}" -- ${cur}))
			break
			;;
		*)
			;;
		esac
	done
}

_tinkerforge()
{
	COMPREPLY=()
	local prev cur
	prev="${COMP_WORDS[COMP_CWORD-1]}"
	cur="${COMP_WORDS[COMP_CWORD]}"

	case "${prev}" in
	--help)
		return 0
		;;
	--version)
		return 0
		;;
	--host)
		_known_hosts
		return 0
		;;
	--port)
		return 0
		;;
	--secret)
		return 0
		;;
	--item-separator)
		return 0
		;;
	--group-separator)
		return 0
		;;
	--no-symbolic-input)
		return 0
		;;
	--no-symbolic-output)
		return 0
		;;
	--duration)
		return 0
		;;
	--timeout)
		return 0
		;;
	--list-devices)
		return 0
		;;
	--list-functions)
		return 0
		;;
	--list-callbacks)
		return 0
		;;
	accelerometer-bricklet|ambient-light-bricklet|ambient-light-v2-bricklet|analog-in-bricklet|analog-in-v2-bricklet|analog-out-bricklet|analog-out-v2-bricklet|barometer-bricklet|can-bricklet|co2-bricklet|color-bricklet|current12-bricklet|current25-bricklet|dc-brick|distance-ir-bricklet|distance-us-bricklet|dual-button-bricklet|dual-relay-bricklet|dust-detector-bricklet|gps-bricklet|hall-effect-bricklet|humidity-bricklet|imu-brick|imu-v2-brick|industrial-analog-out-bricklet|industrial-digital-in-4-bricklet|industrial-digital-out-4-bricklet|industrial-dual-0-20ma-bricklet|industrial-dual-analog-in-bricklet|industrial-quad-relay-bricklet|io16-bricklet|io4-bricklet|joystick-bricklet|laser-range-finder-bricklet|lcd-16x2-bricklet|lcd-20x4-bricklet|led-strip-bricklet|line-bricklet|linear-poti-bricklet|load-cell-bricklet|master-brick|moisture-bricklet|motion-detector-bricklet|multi-touch-bricklet|nfc-rfid-bricklet|oled-128x64-bricklet|oled-64x48-bricklet|piezo-buzzer-bricklet|piezo-speaker-bricklet|ptc-bricklet|real-time-clock-bricklet|red-brick|remote-switch-bricklet|rgb-led-bricklet|rotary-encoder-bricklet|rotary-poti-bricklet|rs232-bricklet|segment-display-4x7-bricklet|servo-brick|silent-stepper-brick|solid-state-relay-bricklet|sound-intensity-bricklet|stepper-brick|temperature-bricklet|temperature-ir-bricklet|thermocouple-bricklet|tilt-bricklet|uv-light-bricklet|voltage-bricklet|voltage-current-bricklet)
		local host port secret options
		host=""
		port=""
		secret=""
		options=""

		for (( i=${COMP_CWORD}; i > 0; i-- )); do
			case "${COMP_WORDS[i]}" in
			--host)
				case "${COMP_WORDS[i+1]}" in
				=)
					host="--host ${COMP_WORDS[i+2]}"
					;;
				*)
					host="--host ${COMP_WORDS[i+1]}"
					;;
				esac
				;;
			--port)
				case "${COMP_WORDS[i+1]}" in
				=)
					port="--port ${COMP_WORDS[i+2]}"
					;;
				*)
					port="--port ${COMP_WORDS[i+1]}"
					;;
				esac
				;;
			--secret)
				case "${COMP_WORDS[i+1]}" in
				=)
					secret="--secret ${COMP_WORDS[i+2]}"
					;;
				*)
					secret="--secret ${COMP_WORDS[i+1]}"
					;;
				esac
				;;
			call)
				options="--list-functions"
				;;
			dispatch)
				options="--list-callbacks"
				;;
			*)
				;;
			esac
		done

		local uids=$(tinkerforge ${host} ${port} ${secret} enumerate --duration 100 --execute "if [ {device-identifier} = '${COMP_WORDS[COMP_CWORD-1]}' ]; then echo {uid}; fi" 2> /dev/null)
		COMPREPLY=($(compgen -W "--help ${options} ${uids}" -- ${cur}))
		return 0
		;;
	--execute)
		return 0
		;;
	--expect-response)
		return 0
		;;
	*)
		;;
	esac

	for (( i=${COMP_CWORD}; i > 0; i-- )); do
		prev="${COMP_WORDS[i-1]}"

		case "${prev}" in
		tinkerforge)
			COMPREPLY=($(compgen -W "--help --host --port --secret --item-separator --group-separator --no-symbolic-input --no-symbolic-output call dispatch enumerate listen" -- ${cur}))
			break
			;;
		call)
			local devices=$(tinkerforge call --list-devices)
			COMPREPLY=($(compgen -W "--help --list-devices --timeout ${devices}" -- ${cur}))
			break
			;;
		dispatch)
			local devices=$(tinkerforge dispatch --list-devices)
			COMPREPLY=($(compgen -W "--help --list-devices --duration ${devices}" -- ${cur}))
			break
			;;
		enumerate)
			COMPREPLY=($(compgen -W "--help --duration --types --execute" -- ${cur}))
			break
			;;
		listen)
			COMPREPLY=($(compgen -W "--help --address --port --enable-host --enable-port --enable-execute" -- ${cur}))
			break
			;;
		accelerometer-bricklet|ambient-light-bricklet|ambient-light-v2-bricklet|analog-in-bricklet|analog-in-v2-bricklet|analog-out-bricklet|analog-out-v2-bricklet|barometer-bricklet|can-bricklet|co2-bricklet|color-bricklet|current12-bricklet|current25-bricklet|dc-brick|distance-ir-bricklet|distance-us-bricklet|dual-button-bricklet|dual-relay-bricklet|dust-detector-bricklet|gps-bricklet|hall-effect-bricklet|humidity-bricklet|imu-brick|imu-v2-brick|industrial-analog-out-bricklet|industrial-digital-in-4-bricklet|industrial-digital-out-4-bricklet|industrial-dual-0-20ma-bricklet|industrial-dual-analog-in-bricklet|industrial-quad-relay-bricklet|io16-bricklet|io4-bricklet|joystick-bricklet|laser-range-finder-bricklet|lcd-16x2-bricklet|lcd-20x4-bricklet|led-strip-bricklet|line-bricklet|linear-poti-bricklet|load-cell-bricklet|master-brick|moisture-bricklet|motion-detector-bricklet|multi-touch-bricklet|nfc-rfid-bricklet|oled-128x64-bricklet|oled-64x48-bricklet|piezo-buzzer-bricklet|piezo-speaker-bricklet|ptc-bricklet|real-time-clock-bricklet|red-brick|remote-switch-bricklet|rgb-led-bricklet|rotary-encoder-bricklet|rotary-poti-bricklet|rs232-bricklet|segment-display-4x7-bricklet|servo-brick|silent-stepper-brick|solid-state-relay-bricklet|sound-intensity-bricklet|stepper-brick|temperature-bricklet|temperature-ir-bricklet|thermocouple-bricklet|tilt-bricklet|uv-light-bricklet|voltage-bricklet|voltage-current-bricklet)
			_tinkerforge_device ${COMP_CWORD} ${prev}
			break
			;;
		*)
			;;
		esac
	done

	return 0
}

complete -F _tinkerforge tinkerforge
